#include <fstream>
#include <iostream>
#include <string>
#include <math.h>
using namespace std;

#define d 4
int name_input;
double theta0[d];           // 4*1  matrix, prob of a, c, g, t (4 row)
double theta1[d][d];        // 4*4  matrix, prob of a, c, g, t (4 row), given the previous is a, c, g, t (4 col)
double theta2[d][d*d];      // 4*16 matrix, prob of a, c, g, t (4 row), given the previous is aa, ca, ga, ta, ... tt (16 col)
double theta3[d][d*d*d];    // 4*64 matrix, prob of a, c, g, t (4 row), given the previous is aaa, caa, gaa, taa, ... ttt (64 col)

string data;
string tmp;

int main (int argc, char **argv)
{
   int i,j;
	
   for(i=1;i<argc-1;i++)
	{
     if(strcmp(argv[i],"-i")==0) {name_input=i+1; i++;}
    }

   ifstream infile; 
   infile.open(argv[ name_input ]); 

   i=0;
   while(!infile.eof())
   {
    if(i==0) getline(infile, data); 
    else if(i>0)
    {
	 getline(infile, tmp); 
     data.append(tmp);
    }
	i++;
   }
   infile.close();

/*******************************************/
for(i=0;i<d;i++) theta0[i]=0.0;
for(i=0;i<d;i++){ for(j=0;j<d;j++) theta1[i][j]=0.0; }
for(i=0;i<d;i++){ for(j=0;j<d*d;j++) theta2[i][j]=0.0; }
for(i=0;i<d;i++){ for(j=0;j<d*d*d;j++) theta3[i][j]=0.0; }

for(i=0;i<data.length();i++)
{
 theta0[ data[i]-48 ]++;
 if(i>=1) { theta1[ data[i]-48 ][ data[i-1]-48 ]++; }
 if(i>=2) { theta2[ data[i]-48 ][ (data[i-2]-48) + 4*(data[i-1]-48) ]++; }
 if(i>=3) { theta3[ data[i]-48 ][ (data[i-3]-48) + 4*(data[i-2]-48) + 16*(data[i-1]-48) ]++; }
}

 FILE *s;
 s=fopen("theta0.txt", "w");
 for(i=0;i<d;i++)
     fprintf(s, "%lf\n", theta0[i]/data.length());
 fclose(s);

 s=fopen("theta1.txt", "w");
 for(i=0;i<d;i++)
 {
  for(j=0;j<d;j++)
     fprintf(s, "%lf	", theta1[i][j]/theta0[j]);
  fprintf(s, "\n");
 }
 fclose(s);

 s=fopen("theta2.txt", "w");
 for(i=0;i<d;i++)
 {
  for(j=0;j<d*d;j++)
     fprintf(s, "%lf	", theta2[i][j]/theta1[j/4][j%4]);
  fprintf(s, "\n");
 }
 fclose(s);

 s=fopen("theta3.txt", "w");
 for(i=0;i<d;i++)
 {
  for(j=0;j<d*d*d;j++)
     fprintf(s, "%lf	", theta3[i][j]/theta2[j/16][j%16]);
  fprintf(s, "\n");
 }
 fclose(s);

 printf("3-order Markov Background End!\n");

   return 0;
}
